<?php
/**
 * Created by PhpStorm.
 * User: ag-websolutions.de
 * Date: 16.10.2016
 * Time: 12:29
 *
 * File: class.agws_zaremover.php
 * Project: agws_zaremover
 */
class agws_zaremover
{
    /**
     * agws_zaremover constructor.
     * @param Plugin $oPlugin
     * @param $helper
     */
    function __construct(Plugin $oPlugin, $helper)
    {
        $this->plugin = $oPlugin;
        $this->helper = $helper;
    }

    /**
     * @param bool $bAktiv
     * @return array|int|object
     */
    function holeZahlungsmethoden($bAktiv = true) {
        $cSQLWhere = "WHERE tzahlungsart.nActive = 1 AND tversandartzahlungsart.kZahlungsart = tzahlungsart.kZahlungsart";
        if(!$bAktiv)
            $cSQLWhere = "";

        $sql = "SELECT tzahlungsart.cName,  tzahlungsart.cModulId
		    FROM tzahlungsart, tversandartzahlungsart
			" . $cSQLWhere . "
			GROUP BY tzahlungsart.kZahlungsart
			ORDER BY tzahlungsart.cModulId";

        ($this->helper->isShop4()) ? $oZahlungsmethode_arr = Shop::DB()->query($sql,2) : $oZahlungsmethode_arr = $GLOBALS["DB"]->executeQuery($sql,2);

        return $oZahlungsmethode_arr;
    }

    /**
     * @param $agws_zaremover_sql
     * @param $agws_seitennavi_start
     * @param $agws_seitennavi_MAX_EINTRAEGE
     * @return array|int|object
     */
    function holeAlleKunden($agws_zaremover_sql, $agws_seitennavi_start, $agws_seitennavi_MAX_EINTRAEGE) {
        $cSQLWhere = $agws_zaremover_sql;
        $sql = "SELECT tkunde.kKunde, tkunde.cNachname, tkunde.cVorname, tkunde.cFirma, tkunde.cMail
			FROM tkunde
			" . $cSQLWhere . "
			GROUP BY tkunde.kKunde
			ORDER BY tkunde.kKunde
			LIMIT $agws_seitennavi_start, ".$agws_seitennavi_MAX_EINTRAEGE;

        ($this->helper->isShop4()) ? $oAlleKunden_arr = Shop::DB()->query($sql,2) : $oAlleKunden_arr = $GLOBALS["DB"]->executeQuery($sql,2);

        if(is_array($oAlleKunden_arr) && count($oAlleKunden_arr) > 0) {
            foreach($oAlleKunden_arr as $oAlleKunden) {
                $oAlleKunden->cNachname =  trim(entschluesselXTEA($oAlleKunden->cNachname));
                $oAlleKunden->cFirma =  trim(entschluesselXTEA($oAlleKunden->cFirma));
            }
        }

        return $oAlleKunden_arr;
    }

    /**
     * @param $kkn
     */
    function loescheSpeziKunde($kkn) {
        $sql = "DELETE FROM xplugin_agws_zaremover_tzaremove WHERE kKundennr='".(int)$kkn."'";
        ($this->helper->isShop4()) ? $bDel = Shop::DB()->query($sql,4) : $bDel = $GLOBALS["DB"]->executeQuery($sql,4);
    }

    /**
     * @param $kkn
     * @param $cZaremove
     */
    function setzeSpeziKunde($kkn, $cZaremove) {
        $sql = "INSERT INTO xplugin_agws_zaremover_tzaremove SET kKundennr='".(int)$kkn."', cZaremove='".$cZaremove."'";
        ($this->helper->isShop4()) ? $bIns = Shop::DB()->query($sql,4) : $bIns = $GLOBALS["DB"]->executeQuery($sql,4);
    }

    /**
     * @return array|int|object
     */
    function holeSpeziKunden($cSQLWhere, $agws_seitennavi_start, $agws_seitennavi_MAX_EINTRAEGE) {
//        $cSQLWhere = "WHERE xplugin_agws_zaremover_tzaremove.kKundennr=tkunde.kKunde";
        $sql = "SELECT xplugin_agws_zaremover_tzaremove.kKundennr, tkunde.cNachname, tkunde.cVorname, tkunde.cFirma, tkunde.cMail, xplugin_agws_zaremover_tzaremove.cZaremove
			FROM xplugin_agws_zaremover_tzaremove, tkunde" . $cSQLWhere . " 
			AND xplugin_agws_zaremover_tzaremove.kKundennr=tkunde.kKunde 
			ORDER BY tkunde.kKunde
			LIMIT $agws_seitennavi_start, ".$agws_seitennavi_MAX_EINTRAEGE;

        ($this->helper->isShop4()) ? $oSpeziKunden_arr = Shop::DB()->query($sql, 2) : $oSpeziKunden_arr = $GLOBALS["DB"]->executeQuery($sql, 2);

        if (is_array($oSpeziKunden_arr) && count($oSpeziKunden_arr) > 0) {
            foreach ($oSpeziKunden_arr as $oSpeziKunden) {
                $oSpeziKunden->cNachname = trim(entschluesselXTEA($oSpeziKunden->cNachname));
                $oSpeziKunden->cFirma = trim(entschluesselXTEA($oSpeziKunden->cFirma));

                $oZaRemove_arr = explode("||", $oSpeziKunden->cZaremove);
                $oSpeziKunden->oZaRemove_arr = $oZaRemove_arr;
            }
        }

        return $oSpeziKunden_arr;
    }

    /**
     * @param $kKundenNr
     * @return array|int|object
     */
    function holeSpeziKundenFrontend($kKundenNr) {
        $sql = 'SELECT xplugin_agws_zaremover_tzaremove.kKundennr, xplugin_agws_zaremover_tzaremove.cZaremove
		 FROM xplugin_agws_zaremover_tzaremove
		 WHERE xplugin_agws_zaremover_tzaremove.kKundennr='.(int)$kKundenNr;

        ($this->helper->isShop4()) ? $oSpeziKunden_arr = Shop::DB()->query($sql,8) : $oSpeziKunden_arr = $GLOBALS["DB"]->executeQuery($sql,8);

        return $oSpeziKunden_arr;
    }
	
	function ermittleGesamtAnzahl($agws_zaremover_sql) {
		$sql = "SELECT COUNT(*) AS agws_seitennavi_menge FROM tkunde" . $agws_zaremover_sql;
    	($this->helper->isShop4()) ? $agws_seitennavi_resultGesamt = Shop::DB()->query($sql,8) : $agws_seitennavi_resultGesamt = $GLOBALS["DB"]->executeQuery($sql,8);
		
		return $agws_seitennavi_resultGesamt;
	}

    function ermittleGesamtAnzahlDashboard($agws_zaremover_sql) {
        $sql = "SELECT COUNT(*) AS agws_seitennavi_menge FROM xplugin_agws_zaremover_tzaremove, tkunde " . $agws_zaremover_sql . " AND xplugin_agws_zaremover_tzaremove.kKundennr = tkunde.kKunde";
        ($this->helper->isShop4()) ? $agws_seitennavi_resultGesamt = Shop::DB()->query($sql,8) : $agws_seitennavi_resultGesamt = $GLOBALS["DB"]->executeQuery($sql,8);

        return $agws_seitennavi_resultGesamt;
    }

    function to_utf8( $string ) {
// From http://w3.org/International/questions/qa-forms-utf-8.html
        if ( preg_match('%^(?:
      [\x09\x0A\x0D\x20-\x7E]            # ASCII
    | [\xC2-\xDF][\x80-\xBF]             # non-overlong 2-byte
    | \xE0[\xA0-\xBF][\x80-\xBF]         # excluding overlongs
    | [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}  # straight 3-byte
    | \xED[\x80-\x9F][\x80-\xBF]         # excluding surrogates
    | \xF0[\x90-\xBF][\x80-\xBF]{2}      # planes 1-3
    | [\xF1-\xF3][\x80-\xBF]{3}          # planes 4-15
    | \xF4[\x80-\x8F][\x80-\xBF]{2}      # plane 16
)*$%xs', $string) ) {
            return $string;
        } else {
            return iconv( 'CP1252', 'UTF-8', $string);
        }
    }

}