<?php
/**
 * @Copyright (c) 2016 - ag-websolutions.de
 * @Lizenz siehe Datei: LICENSE.md / license see file: LICENSE.md
 */

global $oPlugin;

require_once(PFAD_ROOT . PFAD_INCLUDES . "tools.Global.php");
require_once($oPlugin->cAdminmenuPfad . "inc/class.agws_zaremover.php");
require_once $oPlugin->cAdminmenuPfad . 'inc/class.agws_plugin_all.helper.php';

$helper = agwsPluginHelperAll::getInstance($oPlugin);

if ($helper->isShop4()) {
    $smarty = Shop::Smarty();
} else {
    global $smarty;
}

$hinweis = "Kein Datensatz vorhanden";

$agws_zaremover_class = new agws_zaremover($oPlugin,$helper);
$agws_zaremover_sql= "WHERE tkunde.nRegistriert=1";
$agws_seitennavi_start = 0;
$agws_seitenNavi_MaxEntries = 100;

$filter_kdnr = "";
$filter_email = "";
$filter_vorname = "";

if (isset($_POST['filter_kdnr']))
    $filter_kdnr = urlencode($_POST['filter_kdnr']);

if($filter_kdnr=="" && isset($_GET['filter_kdnr']))
    $filter_kdnr = urlencode($_GET['filter_kdnr']);

if (isset($_POST['filter_email']))
    $filter_email = urlencode($_POST['filter_email']);

if($filter_email=="" && isset($_GET['filter_email']))
    $filter_email = urlencode($_GET['filter_email']);

if (isset($_POST['filter_vorname']))
    $filter_vorname = urlencode($_POST['filter_vorname']);

if($filter_vorname=="" && isset($_GET['filter_vorname']))
    $filter_vorname = urlencode($_GET['filter_vorname']);

if (isset($filter_kdnr) && $filter_kdnr!="")
    $agws_zaremover_sql=" WHERE kKunde LIKE '".urldecode($filter_kdnr)."' AND tkunde.nRegistriert=1";

if (isset($filter_email) && $filter_email!="")
    $agws_zaremover_sql=" WHERE cMail LIKE '".urldecode($filter_email)."' AND tkunde.nRegistriert=1";

if (isset($filter_vorname) && $filter_vorname!="")
    $agws_zaremover_sql=" WHERE cVorname LIKE '".urldecode($filter_vorname)."' AND tkunde.nRegistriert=1";

if (isset($_POST['agws_zaremover_change']) && $_POST['agws_zaremover_change']=="change") {
    foreach($_POST['agws_zaremover_item'] as $agws_zaremover_item_single) {
        if (isset($agws_zaremover_item_single['ZAREM_CHECK']) && $agws_zaremover_item_single['ZAREM_CHECK']=="on") {
            $agws_zaremover_item_single_select_arr="";

            if (isset($agws_zaremover_item_single['ZAREM_SELECT'])) {
                foreach($agws_zaremover_item_single['ZAREM_SELECT'] as $agws_zaremover_item_single_select) {
                    $agws_zaremover_item_single_select_arr.=$agws_zaremover_item_single_select."||";
                }
            }

            if ($agws_zaremover_item_single_select_arr != "") {
                $agws_zaremover_class->loescheSpeziKunde($agws_zaremover_item_single['ZAREM_ID']);
                $agws_zaremover_class->setzeSpeziKunde($agws_zaremover_item_single['ZAREM_ID'], substr($agws_zaremover_item_single_select_arr, 0, (strlen($agws_zaremover_item_single_select_arr)-2)));
            } else {
                $agws_zaremover_class->loescheSpeziKunde($agws_zaremover_item_single['ZAREM_ID']);
            }
        }
    }
}

if (isset($filter_kdnr) && $filter_kdnr!="" || isset($filter_email) && $filter_email!="" || isset($filter_vorname) && $filter_vorname!="") {
    /** Beginn - Aufbau der Seiten-Pagination **/
    // Wieviel Eintrge pro Seite sollen dargestellt werden?
	$agws_seitenNavi_MaxEntries = (int)$oPlugin->oPluginEinstellungAssoc_arr['agws_zaremover_setting_table'];

    // Die Berechnung erfolgt nur fr ungerade Zahlen!!!
    define("AGWS_SEITENNAVI_NAV_LEISTE",5);

    // Die aktuell angeforderte Seite
    $agws_seitennavi_seiteAktuell = (isset($_REQUEST['agws_seitennavi_site'])) ? (int)$_REQUEST['agws_seitennavi_site'] : "";

    // Falls noch keine Seitenzahl bergeben wurde, den Wert auf die erste Seite setzen
    if(empty($agws_seitennavi_seiteAktuell))
        $agws_seitennavi_seiteAktuell = 1;

    // Berechnet die nchsten Eintraege aus MAX_EINTRAEGE
    $agws_seitennavi_start = $agws_seitennavi_seiteAktuell * $agws_seitenNavi_MaxEntries - $agws_seitenNavi_MaxEntries;

    // Ermittelt die Gesamtzahl der Datenstze
	$agws_seitennavi_resultGesamt = $agws_zaremover_class->ermittleGesamtAnzahl($agws_zaremover_sql);

    // Errechnet die kompletten Seiten
    $agws_seitennavi_SitesComplete = ceil($agws_seitennavi_resultGesamt['agws_seitennavi_menge'] / $agws_seitenNavi_MaxEntries);

    (isset($filter_kdnr)) ? $filter_kdnr = "&filter_kdnr=".$filter_kdnr : $filter_kdnr = "";
    (isset($filter_email)) ? $filter_email = "&filter_email=".$filter_email : $filter_email = "";
    (isset($filter_vorname)) ? $filter_vorname = "&filter_vorname=".$filter_vorname : $filter_vorname = "";
    // Weitere Variablen den Seitenzahlem mit bergeben:
    $agws_seitennavi_extVariables ='&kPlugin='.$oPlugin->kPlugin.'&cPluginTab=ZARemover-Setting'.$filter_kdnr.$filter_email.$filter_vorname;

    // Navigation aufbauen
    $agws_seitennavi_arr=new stdClass();

    // Die Menge der angezeigten Links fr die Seiten werden errechnet
    $agws_seitennavi_arr->SitesComplete = $agws_seitennavi_SitesComplete;
    $agws_seitennavi_arr->seiteAktuell = $agws_seitennavi_seiteAktuell;
    $agws_seitennavi_arr->extVariables = $agws_seitennavi_extVariables;
    $agws_seitennavi_arr->NavCeil = floor(AGWS_SEITENNAVI_NAV_LEISTE / 2);

    $smarty->assign("agws_seitennavi_arr", $agws_seitennavi_arr);
    /** Ende - Aufbau der Seiten-Pagination **/

}
    
$oAlleKunden_arr = $agws_zaremover_class->holeAlleKunden($agws_zaremover_sql,$agws_seitennavi_start,$agws_seitenNavi_MaxEntries);
$oZahlungsmethode_arr = $agws_zaremover_class->holeZahlungsmethoden();
if(is_array($oAlleKunden_arr) && count($oAlleKunden_arr) > 0)
    $hinweis = "";

$smarty->assign("oZahlungsmethode_arr", $oZahlungsmethode_arr);
$smarty->assign("oAlleKunden_arr", $oAlleKunden_arr);
$smarty->assign("oHinweis2", $hinweis);

$smarty->display($oPlugin->cAdminmenuPfad . "templates/agws_zaremover_setting.tpl");